# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-13. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
На автозаправочных станциях (АЗС) продается бензин с маркировкой 92,
95 и 98. В городе N был проведен мониторинг цены бензина на различных
АЗС. Напишите эффективную по времени работы и по используемой памяти
программу (укажите используемую версию языка программирования,
например, Borland Pascal 7.0), которая будет определять для каждого
вида бензина, сколько АЗС продают его дешевле всего. 
На вход программе в первой строке подается число данных N о стоимости
бензина. В каждой из последующих N строк находится информация в
следующем формате: 
    <Компания> <Улица> <Марка> <Цена> 
где <Компания> – строка, состоящая не более, чем из 20 символов без
пробелов, <Улица> – строка, состоящая не более, чем из 20 символов без
пробелов, <Марка> – одно из чисел – 92, 95 или 98, <Цена> – целое
число в диапазоне от 1000 до 3000, обозначающее стоимость одного литра
бензина в копейках. 
<Компания> и <Улица>, <Улица> и <Марка>, а также <Марка> и <Цена>
разделены ровно одним пробелом. Пример входной строки: 
    Синойл Цветочная 95 2250 
Программа должна выводить через пробел 3 числа – количество АЗС,
продающих дешевле всего 92-й, 95-й и 98-й бензин соответственно. Если
бензин какой-то марки нигде не продавался, то следует вывести 0. 
Пример выходных данных: 
    12 1 0
"""
import sys, codecs
save_stdin = sys.stdin
sys.stdin = codecs.open("in/13.in", "r", "utf-8")

N = int(input())
res = {}
for i in range(N):
    firm, street, mark, price = input().split()
    mark = int(mark)
    price = int(price)
    prev_data = res.get(mark)
    if prev_data == None:
        res[mark] = (price, 1)
    else:
        if price == prev_data[0]:
            res[mark] = (price, prev_data[1]+1)
        if price < prev_data[0]:
            res[mark] = (price, 1)
for mark in [92,95,98]:
    data = res.get(mark)
    if data == None:
        print(0, end = " ")
    else:
        print(data[1], end = " ")

sys.stdin = save_stdin