# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-15. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
В соревнованиях по многоборью (из M видов спорта) участвуют N
спортсменов (N < 1000) . На вход программе в первой строке подается
число спортсменов N, во второй – число видов спорта M. В каждой из
последующих N строк находится информация в следующем формате: 
    <Фамилия> <Имя> <Баллы> 
где <Фамилия> – строка, состоящая не более, чем из 20 символов без
пробелов, <Имя> – строка, состоящая не более, чем из 12 символов без
пробелов, <Баллы> – M целых чисел, обозначающие количество баллов,
набранных спортсменом в каждом из видов многоборья. 
<Фамилия> и <Имя>, <Имя> и <Баллы>, а также отдельные числа в поле
<Баллы> разделены ровно одним пробелом. Пример входных строк: 
    3
    4
    Иванов Сергей 100 30 78 13
    Петров Антон 90 16 98 14
    Сидоров Юрий 100 70 30 21 
Программа должна выводить результирующую таблицу, содержащую список
спортсменов, отсортированный по убыванию суммы баллов, набранные суммы
и занятые места.
В данном случае программа должна вывести 
    Иванов Сергей 221 1
    Сидоров Юрий 221 1
    Петров Антон 218 2
"""
import sys, codecs
save_stdin = sys.stdin
sys.stdin = codecs.open("in/15.in", "r", "utf-8")

N = int(input())
M = int(input())
res = []
for i in range(N):
    data = input().split()
    balls = [int(x) for x in data[2:]]
    res.append( (data[0]+" "+data[1], sum(balls)))

res.sort(key = lambda x: x[1], reverse = True)
place = 0
for i in range(N):
    if place == 0  or res[i][1] < res[i-1][1]:
        place += 1
    print("%s %d %d" % (res[i][0], res[i][1], place))

sys.stdin = save_stdin