﻿# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-41. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
Вам необходимо написать программу анализа текста. На вход программе
подаются строки, содержащие английские слова. В одной строке может быть 
произвольное количество слов. Все слова записаны строчными (маленькими)
английскими буквами. Между словами в строке может быть один или больше
пробелов, возможны пробелы в начале и в конце строки. Других символов,
кроме строчных английских букв и пробелов, в строках нет. Длина каждой
строки не превышает 200 символов. Количество строк неизвестно, общее
количество слов не более одного миллиона. Конец ввода обозначается
строкой, содержащей единственный символ «*».
Напишите эффективную, в том числе по памяти, программу, которая будет
определять количество слов, начинающихся на каждую букву английского 
алфавита, и выводить эти количества и соответствующие им буквы в порядке
убывания. Если количество слов, начинающихся на какие-то буквы,
совпадает, эти буквы следует выводить в алфавитном порядке. Если на
какую-то букву слов нет, выводить эту букву не надо.
Размер памяти, которую использует Ваша программа, не должен зависеть от
размера исходного списка.
Перед текстом программы кратко опишите используемый Вами алгоритм 
решения задачи и укажите используемый язык программирования и его версию.
Пример входных данных: 
     one two three four five 
        a quick brown fox
    *
Пример выходных данных для приведенного выше примера входных данных: 
    f 3 
    t 2 
    а 1 
    b 1 
    о 1
    q 1
Примечание. Английский алфавит совпадает с латинским и содержит 26 букв
от а до z: 
abcdefghijklmnopqrstuvwxyz
"""
import sys
save_stdin = sys.stdin
sys.stdin = open("in/41.in")

import string
cnt = {}
while True:
    s = input()
    if s == '*': break
    words = s.split()
    for w in words:
        cnt[w[0]] = cnt.get(w[0],0) + 1

cnt = sorted(cnt.items(), key = lambda x: x[1], reverse = True)
for x in cnt:
    print(x[0], x[1])

sys.stdin = save_stdin