# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-45. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
На вход программе подаются сведения о пассажирах, желающих сдать свой
багаж в камеру хранения на заранее известное время до полуночи. В первой 
строке сообщается число пассажиров N, которое не меньше 3, но не 
превосходит 1000; во второй строке – количество ячеек в камере хранения
K, которое не меньше 10, но не превосходит 1000. Каждая из следующих N
строк имеет следующий формат:
<Фамилия> <время сдачи багажа> <время освобождения ячейки>,
где <Фамилия> – строка, состоящая не более чем из 20 непробельных
символов; <время сдачи багажа> – через двоеточие два целых числа,
соответствующие часам (от 00 до 23 – ровно 2 символа) и минутам (от 00
до 59 – ровно 2 символа); <время освобождения ячейки> имеет тот же 
формат. <Фамилия> и <время сдачи багажа>, а также <время сдачи багажа>
и <время освобождения ячейки> разделены одним пробелом. Время
освобождения больше времени сдачи.
Сведения отсортированы в порядке времени сдачи багажа. Каждому из
пассажиров в камере хранения выделяется свободная ячейка с минимальным 
номером. Если в момент сдачи багажа свободных ячеек нет, то пассажир
уходит, не дожидаясь освобождения одной из них.
Требуется написать программу (укажите используемую версию языка
программирования, например Borland Pascal 7.0), которая будет выводить 
на экран для каждого пассажира номер ему предоставленной ячейки (можно
сразу после ввода данных очередного пассажира). Если ячейка пассажиру не
предоставлена, то его фамилия не печатается.
Пример входных данных:
    3
    10
    Иванов 09:45 12:00
    Петров 10:00 11:00
    Сидоров 12:00 13:12
Результат работы программы на этих входных данных:
    Иванов 1
    Петров 2
    Сидоров 1
"""
import sys, codecs
save_stdin = sys.stdin
sys.stdin = codecs.open("in/45.in", "r", "utf-8")

N = int(input())
K = int(input())
freeTime = ['00:00'] * K
passList = []
for i in range(N):
    fam, startTime, endTime = input().split()
    cell = 0
    while cell < K:
        if startTime >= freeTime[cell]:
            freeTime[cell] = endTime
            passList.append( (fam, cell + 1) )
            break
        cell += 1

for p in passList:
    print(p[0], p[1])

sys.stdin = save_stdin