# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-48. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013-2016
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
Соревнования по игре «Тетрис-онлайн» проводятся по следующим правилам.
Каждый участник регистрируется на сайте игры под определённым игровым 
именем. Имена участников не повторяются.
Чемпионат проводится в течение определённого времени. В любой момент
этого времени любой зарегистрированный участник может зайти на сайт 
чемпионата и начать зачётную игру. По окончании игры её результат
(количество набранных очков) фиксируется и заносится в протокол.
Участники имеют право играть несколько раз. Количество попыток одного
участника не ограничивается.
Окончательный результат участника определяется по одной игре, лучшей для 
данного участника.
Более высокое место в соревнованиях занимает участник, показавший лучший
результат.
При равенстве результатов более высокое место занимает участник, раньше
показавший лучший результат.
В ходе соревнований заполняется протокол, каждая строка которого
описывает одну игру и содержит результат участника и его игровое имя.
Протокол формируется в реальном времени по ходу проведения чемпионата,
поэтому строки в нём расположены в порядке проведения игр: чем раньше 
встречается строка в протоколе, тем раньше закончилась соответствующая 
этой строке игра.
Напишите эффективную, в том числе по памяти, программу, которая по 
данным протокола определяет победителя и призёров. Гарантируется, что в 
чемпионате участвует не менее трёх игроков.
Перед текстом программы кратко опишите алгоритм решения задачи и укажите 
используемый язык программирования и его версию.
Описание входных данных
Первая строка содержит число N- общее количество строк протокола. Каждая
из следующих N строк содержит записанные через пробел результат
участника (целое неотрицательное число, не превышающее 100 миллионов) и
игровое имя (имя не может содержать пробелов). Строки исходных данных
соответствуют строкам протокола и расположены в том же порядке, что и в
протоколе.
Гарантируется, что количество участников соревнований не меньше 3. 
Описание выходных данных
Программа должна вывести имена и результаты трёх лучших игроков по
форме, приведённой ниже в примере.
Пример входных данных:
    9
    69485 Jack 
    95715 qwerty 
    95715 Alex 
    83647 М 
    197128 qwerty 
    95715 Jack 
    93289 Alex 
    95715 Alex 
    95710 M
Пример выходных данных для приведённого выше примера входных данных:
    1 место. qwerty (197128)
    2 место. Alex (95715)
    3 место. Jack (95715)
"""
import sys, copy
save_stdin = sys.stdin
sys.stdin = open("in/48.in")

class Info:
  def __init__(self, name, res):
    self.name = name
    self.res = res

resList = [Info("",0)]*3
def insert ( res0, name0 ):
  global resList
  newEl = Info(name0, res0)
  if name0 == resList[0].name:
    if res0 > resList[0].res: resList[0] = newEl
  elif name0 == resList[1].name:
    if res0 > resList[0].res:
      resList[1] = resList[0]
      resList[0] = newEl
    elif res0 > resList[1].res: resList[1].res = res0
  elif res0 > resList[0].res:
    resList[2] = resList[1]
    resList[1] = resList[0]
    resList[0] = newEl
  elif res0 > resList[1].res:
    resList[2] = resList[1]
    resList[1] = newEl
  elif res0 > resList[2].res:
    resList[2] = newEl

N = int(input())
for i in range(N):
    res, name = input().split()
    res = int(res)
    insert(res, name)

for i in range(3):
    print("%d место. %s (%d)" % (i+1, resList[i].name, resList[i].res))

sys.stdin = save_stdin